Status: Closed Start date:  

Priority: Normal Due date:  
Category: Filters Estimated time: 0.00 hour

Target version: 5.0.8   

Resolution: Fixed Affected version:  

Description

For example, filtering issues with any notes filter will include issues with blank notes.

Is this a specification?

I don't think the SQL journals.notes IS NOT NULL is appropriate. A journal without notes has an empty string, not NULL.

Steps to reproduce:

1. Load fixtures with rake db:fixtures:load.

2. Update some parameters of an issue without any notes, like issue #3 in fixtures.

3. Filter issues with any string in the notes.

4. The issue #3 is extracted, but it does not have notes containing a string.
Journal table in this example

mysql> select id,journalized_id,created_on,notes from journals;

+----+----------------+---------------------+-----------------------------------------------------

---------------------+

| id | journalized_id | created_on          | notes                                               

                     |

+----+----------------+---------------------+-----------------------------------------------------

---------------------+

|  1 |              1 | 2023-12-28 00:00:00 | Journal notes                                       

                     |

|  2 |              1 | 2023-12-29 00:00:00 | Some notes with Redmine links: #2, r2.              

                     |

|  3 |              2 | 2023-12-29 00:00:00 | A comment with inline image: !picture.jpg! and a ref

erence to #1 and r2. |

|  4 |              6 | 2023-12-29 00:00:00 | A comment with a private version.                   

                     |

|  5 |             14 | 2023-12-29 00:00:00 | A comment on a private issue.                       

                     |

| 10 |              3 | 2023-12-30 11:59:40 |                                                     

                     |

+----+----------------+---------------------+-----------------------------------------------------

---------------------+

6 rows in set (0.01 sec)

 

Actual SQL generated by IssueQuery::sql_for_notes_field

EXISTS (SELECT 1 FROM journals WHERE journals.journalized_type='Issue' AND journals.journalized_id

=issues.id AND (journals.notes IS NOT NULL) AND ((journals.private_notes = FALSE OR journals.

user_id = 1 OR (projects.status <> 9 AND projects.status <> 10))))

 

Environment:

  Redmine version                5.1.1.stable
  Ruby version                   3.2.2-p53 (2023-03-30) [x86_64-linux]

  Rails version                  6.1.7.6

  Environment                    development / productioin

  Database adapter               Mysql2 / PostgreSQL

Related issues:

Related to Redmine - Defect #25077: Issue description filter's 'none' operato... Closed

Associated revisions

Revision 22583 - 2024-01-02 01:41 - Go MAEDA

Fix "any" operator for text filters to exclude empty text values (#39991).

Patch by Go MAEDA (@maeda).

Revision 22587 - 2024-01-03 08:34 - Go MAEDA

Merged r22583 from trunk to 5.1-stable (#39991).

Revision 22588 - 2024-01-03 08:36 - Go MAEDA

Merged r22583 from trunk to 5.0-stable (#39991).

History

#1 - 2024-01-01 05:44 - Go MAEDA

- Related to Defect #25077: Issue description filter's 'none' operator does not match issues with blank descriptions added

#2 - 2024-01-01 06:19 - Go MAEDA

- File 39991.patch added

- Subject changed from Incorrect results when using "none" and "any" parameters in notes filter to Fix "any" operator for text filters to exclude empty

text values

- Status changed from New to Confirmed

- Target version set to 5.0.8

The attached patch fixes the issue.

This bug affects not only with "notes" but also with other text fields.

#3 - 2024-01-02 01:41 - Go MAEDA

- Status changed from Confirmed to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix in r22583.

#4 - 2024-01-03 08:36 - Go MAEDA

- Status changed from Resolved to Closed

Merged the change to stable branches.

#5 - 2024-01-03 18:47 - Yasu Saku

Mr. Go MAEDA, Thank you!

Files

clipboard-202312302147-586r1.png 71 KB 2023-12-30 Yasu Saku

39991.patch 1.91 KB 2024-01-01 Go MAEDA

Powered by TCPDF (www.tcpdf.org)

2025-05-02 2/2

https://www.redmine.org/projects/redmine/repository/svn/revisions/22583
https://www.redmine.org/users/332
http://www.tcpdf.org

